## picotool 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(picotool)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if (DEFINED ENV{PICO_SDK_PATH} AND (NOT PICO_SDK_PATH))
    set(PICO_SDK_PATH $ENV{PICO_SDK_PATH})
    message("Using PICO_SDK_PATH from environment ('${PICO_SDK_PATH}')")
endif ()
if (NOT PICO_SDK_PATH)
    message(FATAL_ERROR "PICO_SDK_PATH is not defined")
endif()
get_filename_component(PICO_SDK_PATH "${PICO_SDK_PATH}" REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
if (NOT EXISTS ${PICO_SDK_PATH})
    message(FATAL_ERROR "Directory '${PICO_SDK_PATH}' not found")
endif ()
include(${PICO_SDK_PATH}/pico_sdk_version.cmake)

if (PICO_SDK_VERSION_STRING VERSION_LESS "2.1.0")
    message(FATAL_ERROR "Raspberry Pi Pico SDK version 2.1.0 (or later) required. Your version is ${PICO_SDK_VERSION_STRING}")
endif()

# Set PICOTOOL_CODE_OTP to compile OTP definitions in - otherwise, they are included from JSON
if (NOT PICOTOOL_CODE_OTP)
    set(PICOTOOL_CODE_OTP 0)
endif()

# allow installing to flat dir
include(GNUInstallDirs)
if (PICOTOOL_FLAT_INSTALL)
    set(INSTALL_CONFIGDIR picotool)
    set(INSTALL_DATADIR picotool)
    set(INSTALL_BINDIR picotool)
else()
    set(INSTALL_CONFIGDIR lib/cmake/picotool)
    set(INSTALL_DATADIR ${CMAKE_INSTALL_DATADIR}/picotool)
    set(INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
endif()

# todo better install paths for this
set(DATA_LOCS "./" "${CMAKE_INSTALL_PREFIX}/${INSTALL_DATADIR}/")
string(REGEX REPLACE ";" "\",\"" DATA_LOCS_VEC "${DATA_LOCS}")
configure_file(data_locs.template.cpp ${CMAKE_CURRENT_BINARY_DIR}/data_locs.cpp)


include(ExternalProject)

if (MSVC)
    set(CMAKE_CXX_STANDARD 20)
else()
    set(CMAKE_CXX_STANDARD 14)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

add_subdirectory(lib)

if (NOT DEFINED USE_PRECOMPILED)
    set(USE_PRECOMPILED true)
endif()


function(add_embedded_data_project TARGET)
    cmake_parse_arguments(PARSE_ARGV 1 OPTS "" "PREFIX;SOURCE_DIR;BINARY_DIR" "CMAKE_ARGS")

    if (USE_PRECOMPILED)
        ExternalProject_Add(${TARGET}
            PREFIX ${OPTS_PREFIX}
            SOURCE_DIR ${OPTS_SOURCE_DIR}
            BINARY_DIR ${OPTS_BINARY_DIR}
            CMAKE_ARGS ${OPTS_CMAKE_ARGS}
            INSTALL_COMMAND ""
            BUILD_ALWAYS 1
        )
    else()
        ExternalProject_Add(${TARGET}
            PREFIX ${OPTS_PREFIX}
            SOURCE_DIR ${OPTS_SOURCE_DIR}
            BINARY_DIR ${OPTS_BINARY_DIR}
            CMAKE_ARGS ${OPTS_CMAKE_ARGS}
            BUILD_ALWAYS 1
        )
    endif()
endfunction()


# compile enc_bootloader.elf
add_embedded_data_project(enc_bootloader
        PREFIX enc_bootloader
        SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/enc_bootloader
        BINARY_DIR ${CMAKE_BINARY_DIR}/enc_bootloader
        CMAKE_ARGS 
            "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
            "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
            "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
            "-DUSE_MBEDTLS=0"
            "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
        )

set(ENC_BOOTLOADER_ELF ${CMAKE_BINARY_DIR}/enc_bootloader/enc_bootloader.elf)

if (TARGET mbedtls)
    add_embedded_data_project(enc_bootloader_mbedtls
            PREFIX enc_bootloader_mbedtls
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/enc_bootloader
            BINARY_DIR ${CMAKE_BINARY_DIR}/enc_bootloader_mbedtls
            CMAKE_ARGS 
                "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
                "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
                "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
                "-DUSE_MBEDTLS=1"
                "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
            )

    set(ENC_BOOTLOADER_MBEDTLS_ELF ${CMAKE_BINARY_DIR}/enc_bootloader_mbedtls/enc_bootloader.elf)
endif()

if (NOT PICOTOOL_NO_LIBUSB)
    # compile xip_ram_perms.elf
    add_embedded_data_project(xip_ram_perms
            PREFIX xip_ram_perms
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/xip_ram_perms
            BINARY_DIR ${CMAKE_BINARY_DIR}/xip_ram_perms
            CMAKE_ARGS 
                "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
                "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
                "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
                "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
            )

    set(XIP_RAM_PERMS_ELF ${CMAKE_BINARY_DIR}/xip_ram_perms/xip_ram_perms.elf)

    # compile flash_id
    add_embedded_data_project(flash_id
            PREFIX picoboot_flash_id
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/picoboot_flash_id
            BINARY_DIR ${CMAKE_BINARY_DIR}/picoboot_flash_id
            CMAKE_ARGS 
                "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
                "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
                "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
                "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
            )

    set(FLASH_ID_BIN ${CMAKE_BINARY_DIR}/picoboot_flash_id/flash_id.bin)

    # We want to generate headers from WELCOME.HTM etc.
    ExternalProject_Add(otp_header_parser
            PREFIX otp_header_parser
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/otp_header_parser
            BINARY_DIR ${CMAKE_BINARY_DIR}/otp_header_parser
            CMAKE_ARGS "-DCODE_OTP=${PICOTOOL_CODE_OTP}"
            BUILD_ALWAYS 1 # todo remove this
            DOWNLOAD_COMMAND ""
            INSTALL_COMMAND ""
            )

    add_executable(otp_header_parse IMPORTED)
    # think this is the best way to do this - this should work in MSVC now, and possibly Xcode but that's untested
    add_dependencies(otp_header_parse otp_header_parser)
    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    if (is_multi_config)
        # use the first config
        list(GET CMAKE_CONFIGURATION_TYPES 0 tmp_config)
        set_property(TARGET otp_header_parse PROPERTY IMPORTED_LOCATION ${CMAKE_BINARY_DIR}/otp_header_parser/${tmp_config}/otp_header_parse)
    else()
        set_property(TARGET otp_header_parse PROPERTY IMPORTED_LOCATION ${CMAKE_BINARY_DIR}/otp_header_parser/otp_header_parse)
    endif()

    if (PICOTOOL_CODE_OTP)
        set(GENERATED_H ${CMAKE_CURRENT_BINARY_DIR}/otp_contents.h)
        add_custom_target(generate_otp_header DEPENDS ${GENERATED_H})
        add_custom_command(OUTPUT ${GENERATED_H}
                COMMENT "Generating ${GENERATED_H}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_H}
                )
    elseif(MSVC)
        set(GENERATED_JSON ${CMAKE_CURRENT_BINARY_DIR}/rp2350_otp_contents.json)
        add_custom_target(generate_otp_header DEPENDS ${GENERATED_JSON})
        add_custom_command(OUTPUT ${GENERATED_JSON}
                COMMENT "Generating ${GENERATED_JSON}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_JSON}
                )
        # Cannot include json in the binary, as the string is too long, so needs to use pre-generated xxd output
        configure_file(${CMAKE_CURRENT_LIST_DIR}/otp_header_parser/rp2350.json.h ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h COPYONLY)
    else()
        set(GENERATED_JSON ${CMAKE_CURRENT_BINARY_DIR}/rp2350_otp_contents.json)
        add_custom_target(generate_otp_header DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h)
        add_custom_command(OUTPUT ${GENERATED_JSON}
                COMMENT "Generating ${GENERATED_JSON}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_JSON}
                )
        add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h
                COMMAND ${CMAKE_COMMAND}
                    -D GENERATED_JSON=${GENERATED_JSON}
                    -P ${CMAKE_CURRENT_LIST_DIR}/cmake/jsonh.cmake
                DEPENDS ${GENERATED_JSON}
                COMMENT "Configuring rp2350.json.h"
                VERBATIM)
              
    endif()
endif()

if (TARGET mbedtls)
    add_custom_target(embedded_data_no_libusb DEPENDS
            ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader_elf.h
            ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader_mbedtls_elf.h)
else()
    add_custom_target(embedded_data_no_libusb DEPENDS
            ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader_elf.h)
endif()

add_custom_target(embedded_data DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms_elf.h
        ${CMAKE_CURRENT_BINARY_DIR}/flash_id_bin.h)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms_elf.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${XIP_RAM_PERMS_ELF}
            -D OUTPUT_NAME=xip_ram_perms_elf
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS xip_ram_perms
        COMMENT "Configuring xip_ram_perms_elf.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader_elf.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${ENC_BOOTLOADER_ELF}
            -D OUTPUT_NAME=enc_bootloader_elf
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS enc_bootloader
        COMMENT "Configuring enc_bootloader_elf.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader_mbedtls_elf.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${ENC_BOOTLOADER_MBEDTLS_ELF}
            -D OUTPUT_NAME=enc_bootloader_mbedtls_elf
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS enc_bootloader_mbedtls
        COMMENT "Configuring enc_bootloader_mbedtls_elf.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/flash_id_bin.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${FLASH_ID_BIN}
            -D OUTPUT_NAME=flash_id_bin
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS flash_id
        COMMENT "Configuring flash_id_bin.h"
        VERBATIM)

add_subdirectory(model)
add_subdirectory(errors)

add_subdirectory(picoboot_connection)
add_subdirectory(elf)
add_subdirectory(elf2uf2)

add_subdirectory(bintool)

if (NOT PICOTOOL_NO_LIBUSB)
    find_package(LIBUSB)
    set(OTP_EXE otp.cpp)
else()
    set(OTP_EXE no_otp.cpp)
endif()

add_subdirectory(${PICO_SDK_PATH}/src/common/pico_binary_info pico_binary_info)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_uf2_headers boot_uf2_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_picoboot_headers boot_picoboot_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_picobin_headers boot_picobin_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/pico_usb_reset_interface_headers pico_usb_reset_interface_headers)
add_subdirectory(${PICO_SDK_PATH}/src/rp2_common/boot_bootrom_headers boot_bootrom_headers)
add_subdirectory(${PICO_SDK_PATH}/src/host/pico_platform pico_platform)

add_library(regs_headers INTERFACE)
target_include_directories(regs_headers INTERFACE ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include)

# Main picotool executable
add_executable(picotool
    data_locs.cpp
    get_enc_bootloader.cpp
    ${OTP_EXE}
    main.cpp)
add_dependencies(picotool embedded_data_no_libusb)
if (NOT PICOTOOL_NO_LIBUSB)
    target_sources(picotool PRIVATE get_xip_ram_perms.cpp)
    add_dependencies(picotool generate_otp_header embedded_data)
endif()
set(PROJECT_VERSION 2.2.0-a4)
set(PICOTOOL_VERSION 2.2.0-a4)
set(SYSTEM_VERSION "${CMAKE_SYSTEM_NAME}")
set(COMPILER_INFO "${CMAKE_C_COMPILER_ID}-${CMAKE_C_COMPILER_VERSION}, ${CMAKE_BUILD_TYPE}")
target_compile_definitions(picotool PRIVATE
        PICOTOOL_VERSION="${PICOTOOL_VERSION}"

=== bintool/CMakeLists.txt ===
if (NOT TARGET mbedtls)
    message("lib/mbedtls submodule needs to be initialized for bintool hashing/signing")
    add_library(bintool STATIC
            bintool.cpp)
    target_compile_definitions(bintool PRIVATE
            NO_PICO_PLATFORM=1
            HAS_MBEDTLS=0
            )

    target_include_directories(bintool PUBLIC ${CMAKE_CURRENT_LIST_DIR})

    target_link_libraries(bintool PUBLIC
            elf
            errors
            boot_picobin_headers)
else()
    add_library(bintool STATIC
            bintool.cpp
            mbedtls_wrapper.c)
    target_compile_definitions(bintool PRIVATE
            NO_PICO_PLATFORM=1
            HAS_MBEDTLS=1
            )

    target_include_directories(bintool PUBLIC ${CMAKE_CURRENT_LIST_DIR})

    target_link_libraries(bintool PUBLIC
            mbedtls
            elf
            errors
            boot_picobin_headers)
endif()

=== elf/CMakeLists.txt ===
add_library(elf STATIC
        elf_file.cpp)

target_include_directories(elf PUBLIC ${CMAKE_CURRENT_LIST_DIR})

target_link_libraries(elf PUBLIC model errors)

=== elf2uf2/CMakeLists.txt ===
add_library(elf2uf2 STATIC
        elf2uf2.cpp)

target_include_directories(elf2uf2 PUBLIC ${CMAKE_CURRENT_LIST_DIR})

target_link_libraries(elf2uf2 PUBLIC elf errors)

=== enc_bootloader/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if (NOT USE_PRECOMPILED)
    set(PICO_PLATFORM rp2350-arm-s)
    
    set(PICO_NO_PICOTOOL 1)

    # Ensure we're using a MinSizeRel build
    set(CMAKE_BUILD_TYPE MinSizeRel)

    # If the user set these environment variables to influence the picotool
    # build, unset them here so that they do not influence the pico-sdk
    # build. This is especially required for flags that are not supported
    # by arm-none-eabi compilers.
    unset(ENV{CFLAGS})
    unset(ENV{CXXFLAGS})
    unset(ENV{LDFLAGS})

    # Pull in SDK (must be before project)
    include(${PICO_SDK_PATH}/external/pico_sdk_import.cmake)

    project(enc_bootloader C CXX ASM)
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_CXX_STANDARD 17)

    if (PICO_SDK_VERSION_STRING VERSION_LESS "2.2.0")
        message(FATAL_ERROR "Raspberry Pi Pico SDK version 2.2.0 (or later) required. Your version is ${PICO_SDK_VERSION_STRING}")
    endif()

    # Initialize the SDK
    pico_sdk_init()

    # Encrypted Bootloader
    add_executable(enc_bootloader
        enc_bootloader.c
    )

    target_link_libraries(enc_bootloader
        pico_stdlib
    )

    if (USE_MBEDTLS)
        target_sources(enc_bootloader PRIVATE mbedtls_aes.c)

        target_link_libraries(enc_bootloader pico_mbedtls)

        target_compile_definitions(enc_bootloader PRIVATE
            PICO_STACK_SIZE=0x800
            # we cannot unreset clk_peri clocked h/w as we don't configure clk_peri
            PICO_RUNTIME_SKIP_INIT_POST_CLOCK_RESETS=1
            RC_COUNT=0 # don't use rcp_count

            # 0x20080000 -> 0x20081000 doesn't overlap the stack
            ROM_CHAIN_WORKSPACE=0x20080000)

        target_include_directories(enc_bootloader PRIVATE ${CMAKE_CURRENT_LIST_DIR})

        pico_set_linker_script(enc_bootloader ${CMAKE_CURRENT_LIST_DIR}/memmap_mbedtls.ld)
    else()
        target_sources(enc_bootloader PRIVATE aes.S hard_entry_point.S)

        target_compile_definitions(enc_bootloader PRIVATE
            PICO_STACK_SIZE=0x180
            # AES Code & workspace from 0x20080044 -> 0x20081604, so 0x20080200 -> 0x20081200 is inside that
            ROM_CHAIN_WORKSPACE=0x20080200)

        pico_set_linker_script(enc_bootloader ${CMAKE_CURRENT_LIST_DIR}/memmap_enc_bootloader.ld)

        target_compile_definitions(enc_bootloader PRIVATE
                # The following are to reduce the size of the binary
                PICO_NO_PROGRAM_INFO=1
                PICO_CRT0_NO_RESET_SECTION=1

                HARDENING=1
                DOUBLE_HARDENING=1

                INLINE_REF_ROUNDKEY_SHARES_S=1 # avoid need for canaries/calling check
                INLINE_REF_ROUNDKEY_HVPERMS_S=1  # avoid need for canaries/calling check
                INLINE_SHIFT_ROWS_S=1  # avoid need for canaries/calling check
                INLINE_MAP_SBOX_S=1  # avoid need for canaries/calling check

                CALLER_INIT_RCP_COUNT=1
        )
    endif()

    target_compile_definitions(enc_bootloader PRIVATE
        # The following are to reduce the size of the binary
        # use stack guards, as AES variables are written near the stack
        PICO_USE_STACK_GUARDS=1
        # No spinlocks used
        PICO_USE_SW_SPIN_LOCKS=0
        # No heap is used
        PICO_HEAP_SIZE=0
        # Note all runtime init is skipped via the linker script

        PICO_BOOTROM_LOCKING_ENABLED=0
        # Don't need any vtor irqs
        PICO_MINIMAL_STORED_VECTOR_TABLE=1
        PICO_NO_RAM_VECTOR_TABLE=1

        PICO_USE_GPIO_COPROCESSOR=0
        FIB_WORKAROUND=1
    )
    if (ALLOW_DEBUGGING)
        target_compile_definitions(enc_bootloader PRIVATE ALLOW_DEBUGGING=1)
    endif()

    # print memory usage
    target_link_options(enc_bootloader PUBLIC -Wl,--print-memory-usage)

    pico_minimize_runtime(enc_bootloader)

    pico_set_binary_type(enc_bootloader no_flash)
    pico_add_dis_output(enc_bootloader)

    if (USE_MBEDTLS)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader.elf DESTINATION ${CMAKE_CURRENT_LIST_DIR} RENAME enc_bootloader_mbedtls.elf)
    else()
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader.elf DESTINATION ${CMAKE_CURRENT_LIST_DIR})
    endif()
else()
    project(enc_bootloader C CXX ASM)
    message("Using precompiled enc_bootloader.elf")
    if (USE_MBEDTLS)
        configure_file(${CMAKE_CURRENT_LIST_DIR}/enc_bootloader_mbedtls.elf ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader.elf COPYONLY)
    else()
        configure_file(${CMAKE_CURRENT_LIST_DIR}/enc_bootloader.elf ${CMAKE_CURRENT_BINARY_DIR}/enc_bootloader.elf COPYONLY)
    endif()
    # Use manually specified variables
    set(NULL ${CMAKE_MAKE_PROGRAM})
    set(NULL ${PICO_SDK_PATH})
    set(NULL ${PICO_DEBUG_INFO_IN_RELEASE})
endif()

=== errors/CMakeLists.txt ===
add_library(errors STATIC errors.cpp)

target_include_directories(errors PUBLIC ${CMAKE_CURRENT_LIST_DIR})

=== lib/CMakeLists.txt ===
# Ensure submodules are initialised - no longer needed as there are no submodules
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
    # Update submodules as needed
    option(GIT_SUBMODULE "Check submodules during build" OFF)
    if(GIT_SUBMODULE)
        message(STATUS "Submodule update")
        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init lib/mbedtls
                        WORKING_DIRECTORY ${PICO_SDK_PATH}
                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
            message("git submodule update --init lib/mbedtls failed with ${GIT_SUBMOD_RESULT}")
        endif()
    endif()
endif()


set(JSON_BuildTests OFF CACHE INTERNAL "")
add_subdirectory(nlohmann_json EXCLUDE_FROM_ALL)

add_subdirectory(whereami EXCLUDE_FROM_ALL)

# Taken from pico-sdk/src/rp2_common/pico_mbedtls/CMakeLists.txt
if (DEFINED ENV{PICO_MBEDTLS_PATH} AND (NOT PICO_MBEDTLS_PATH))
    set(PICO_MBEDTLS_PATH $ENV{PICO_MBEDTLS_PATH})
    message("Using PICO_MBEDTLS_PATH from environment ('${PICO_MBEDTLS_PATH}')")
endif()

set(MBEDTLS_TEST_PATH "library/aes.c")
if (NOT PICO_MBEDTLS_PATH)
    set(PICO_MBEDTLS_PATH ${PICO_SDK_PATH}/lib/mbedtls)
elseif (NOT EXISTS "${PICO_MBEDTLS_PATH}/${MBEDTLS_TEST_PATH}")
    message(WARNING "PICO_MBEDTLS_PATH specified but content not present.")
endif()

if(EXISTS "${PICO_MBEDTLS_PATH}/${MBEDTLS_TEST_PATH}")
    # Support version 2.28.8 or 3.6.2
    if (EXISTS ${PICO_MBEDTLS_PATH}/library/ssl_cli.c)
        set(MBEDTLS_VERSION_MAJOR 2)
    elseif (EXISTS ${PICO_MBEDTLS_PATH}/library/ssl_client.c)
        set(MBEDTLS_VERSION_MAJOR 3)
    else()
        message(WARNING "Cannot determine the version of mbedtls")
    endif()

    function(src_crypto_list)
        set(src_crypto
            aes.c
            aesni.c
            aria.c
            asn1parse.c
            asn1write.c
            base64.c
            bignum.c
            camellia.c
            ccm.c
            chacha20.c
            chachapoly.c
            cipher.c
            cipher_wrap.c
            constant_time.c
            cmac.c
            ctr_drbg.c
            des.c
            dhm.c
            ecdh.c
            ecdsa.c
            ecjpake.c
            ecp.c
            ecp_curves.c
            entropy.c
            entropy_poll.c
            error.c
            gcm.c
            hkdf.c
            hmac_drbg.c
            md.c
            md5.c
            memory_buffer_alloc.c
            mps_reader.c
            mps_trace.c
            nist_kw.c
            oid.c
            padlock.c
            pem.c
            pk.c
            pk_wrap.c
            pkcs12.c
            pkcs5.c
            pkparse.c
            pkwrite.c
            platform.c
            platform_util.c
            poly1305.c
            psa_crypto.c
            psa_crypto_aead.c
            psa_crypto_cipher.c
            psa_crypto_client.c
            psa_crypto_ecp.c
            psa_crypto_hash.c
            psa_crypto_mac.c
            psa_crypto_rsa.c
            psa_crypto_se.c
            psa_crypto_slot_management.c
            psa_crypto_storage.c
            psa_its_file.c
            ripemd160.c
            rsa.c
            sha1.c
            sha256.c
            sha512.c
            threading.c
            timing.c
            version.c
            version_features.c
        )
        if (MBEDTLS_VERSION_MAJOR EQUAL 2)
            list(APPEND src_crypto
                arc4.c
                blowfish.c
                havege.c
                md2.c
                md4.c
                psa_crypto_driver_wrappers.c
                rsa_internal.c xtea.c
            )
        elseif (MBEDTLS_VERSION_MAJOR EQUAL 3)
            list(APPEND src_crypto
                bignum_core.c
                rsa_alt_helpers.c
                pk_ecc.c
            )
        endif()
        list(TRANSFORM src_crypto PREPEND ${PICO_MBEDTLS_PATH}/library/)
        set(src_crypto ${src_crypto} PARENT_SCOPE)
    endfunction()

    src_crypto_list()


    # Create library
    add_library(mbedtls STATIC ${src_crypto})

    if(WIN32)
        target_link_libraries(mbedtls ws2_32 bcrypt)
    endif(WIN32)

    target_compile_definitions(mbedtls PUBLIC MBEDTLS_CONFIG_FILE="picotool_mbedtls_config.h")
    target_include_directories(mbedtls SYSTEM PUBLIC ${PICO_MBEDTLS_PATH}/include)
    target_include_directories(mbedtls PUBLIC ${CMAKE_CURRENT_LIST_DIR}/include)
endif()

=== model/CMakeLists.txt ===
add_library(model STATIC
        model.cpp)

target_include_directories(model PUBLIC ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(model PUBLIC boot_uf2_headers boot_picoboot_headers pico_platform_headers errors)

add_custom_target(unreadable_rom_data DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a2_rom_end.h
        ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a3_rom_end.h
        ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a4_rom_end.h)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a2_rom_end.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${CMAKE_CURRENT_LIST_DIR}/rp2350_a2_rom_end.bin
            -D OUTPUT_NAME=rp2350_a2_rom_end
            -P ${CMAKE_CURRENT_LIST_DIR}/../cmake/binh.cmake
        COMMENT "Configuring rp2350_a2_rom_end.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a3_rom_end.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${CMAKE_CURRENT_LIST_DIR}/rp2350_a3_rom_end.bin
            -D OUTPUT_NAME=rp2350_a3_rom_end
            -P ${CMAKE_CURRENT_LIST_DIR}/../cmake/binh.cmake
        COMMENT "Configuring rp2350_a3_rom_end.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350_a4_rom_end.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${CMAKE_CURRENT_LIST_DIR}/rp2350_a4_rom_end.bin
            -D OUTPUT_NAME=rp2350_a4_rom_end
            -P ${CMAKE_CURRENT_LIST_DIR}/../cmake/binh.cmake
        COMMENT "Configuring rp2350_a4_rom_end.h"
        VERBATIM)

add_dependencies(model unreadable_rom_data)

=== otp_header_parser/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
PROJECT(otp_header_parser CXX)
set(CMAKE_CXX_STANDARD 14)

add_executable(otp_header_parse otp_header_parse.cpp)

if (CODE_OTP)
    target_compile_definitions(otp_header_parse PRIVATE CODE_OTP=${CODE_OTP})
endif()

set(JSON_BuildTests OFF CACHE INTERNAL "")
add_subdirectory(../lib/nlohmann_json ${CMAKE_CURRENT_BINARY_DIR}/../lib/nlohmann_json EXCLUDE_FROM_ALL)

if (NOT TARGET nlohmann_json)
    message(FATAL_ERROR "JSON library not found - check you have all the submodules")
else()
    target_link_libraries(otp_header_parse nlohmann_json)
endif()

=== picoboot_connection/CMakeLists.txt ===
add_library(picoboot_connection_header INTERFACE)
target_include_directories(picoboot_connection_header INTERFACE ${CMAKE_CURRENT_LIST_DIR})

add_library(picoboot_connection INTERFACE)

target_sources(picoboot_connection INTERFACE
        ${CMAKE_CURRENT_LIST_DIR}/picoboot_connection.c)

target_link_libraries(picoboot_connection INTERFACE picoboot_connection_header)

add_library(picoboot_connection_cxx INTERFACE)
target_sources(picoboot_connection_cxx INTERFACE
        ${CMAKE_CURRENT_LIST_DIR}/picoboot_connection_cxx.cpp)

target_link_libraries(picoboot_connection_cxx INTERFACE picoboot_connection)

=== picoboot_flash_id/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if (NOT USE_PRECOMPILED)
    set(PICO_NO_PICOTOOL 1)

    # default build type
    set(CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "build type")

    # If the user set these environment variables to influence the picotool
    # build, unset them here so that they do not influence the pico-sdk
    # build. This is especially required for flags that are not supported
    # by arm-none-eabi compilers.
    unset(ENV{CFLAGS})
    unset(ENV{CXXFLAGS})
    unset(ENV{LDFLAGS})

    include(${PICO_SDK_PATH}/external/pico_sdk_import.cmake)
    project(flash_id C CXX ASM)
    pico_sdk_init()

    add_executable(flash_id flash_id.c)
    target_link_libraries(flash_id PRIVATE
        hardware_regs hardware_structs hardware_flash_headers
    )
    target_link_options(flash_id PRIVATE -nostartfiles -nodefaultlibs -Ttext=0)
    pico_add_bin_output(flash_id)
    pico_add_dis_output(flash_id)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/flash_id.bin DESTINATION ${CMAKE_CURRENT_LIST_DIR})
else()
    project(flash_id C CXX ASM)
    message("Using precompiled flash_id.bin")
    configure_file(${CMAKE_CURRENT_LIST_DIR}/flash_id.bin ${CMAKE_CURRENT_BINARY_DIR}/flash_id.bin COPYONLY)
    # Use manually specified variables
    set(NULL ${CMAKE_MAKE_PROGRAM})
    set(NULL ${PICO_SDK_PATH})
    set(NULL ${PICO_DEBUG_INFO_IN_RELEASE})
endif()

=== xip_ram_perms/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if (NOT USE_PRECOMPILED)
    set(PICO_PLATFORM rp2350-arm-s)
    
    set(PICO_NO_PICOTOOL 1)

    # If the user set these environment variables to influence the picotool
    # build, unset them here so that they do not influence the pico-sdk
    # build. This is especially required for flags that are not supported
    # by arm-none-eabi compilers.
    unset(ENV{CFLAGS})
    unset(ENV{CXXFLAGS})
    unset(ENV{LDFLAGS})

    # Pull in SDK (must be before project)
    include(${PICO_SDK_PATH}/external/pico_sdk_import.cmake)

    project(xip_ram_perms C CXX ASM)
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_CXX_STANDARD 17)

    if (PICO_SDK_VERSION_STRING VERSION_LESS "2.0.0")
        message(FATAL_ERROR "Raspberry Pi Pico SDK version 2.0.0 (or later) required. Your version is ${PICO_SDK_VERSION_STRING}")
    endif()

    # Initialize the SDK
    pico_sdk_init()

    # XIP Ram OTP Perm Setter
    add_executable(xip_ram_perms
        set_perms.c
    )

    target_link_libraries(xip_ram_perms
        pico_stdlib
    )

    pico_set_binary_type(xip_ram_perms no_flash)
    # create linker script to run from 0x20070000
    file(READ ${PICO_LINKER_SCRIPT_PATH}/memmap_no_flash.ld LINKER_SCRIPT)
    string(REPLACE "RAM(rwx) : ORIGIN =  0x20000000, LENGTH = 512k" "RAM(rwx) : ORIGIN =  0x13ffc000, LENGTH = 16k" LINKER_SCRIPT "${LINKER_SCRIPT}")
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/memmap_xip_ram.ld "${LINKER_SCRIPT}")
    pico_set_linker_script(xip_ram_perms ${CMAKE_CURRENT_BINARY_DIR}/memmap_xip_ram.ld)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms.elf DESTINATION ${CMAKE_CURRENT_LIST_DIR})
else()
    project(xip_ram_perms C CXX ASM)
    message("Using precompiled xip_ram_perms.elf")
    configure_file(${CMAKE_CURRENT_LIST_DIR}/xip_ram_perms.elf ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms.elf COPYONLY)
    # Use manually specified variables
    set(NULL ${CMAKE_MAKE_PROGRAM})
    set(NULL ${PICO_SDK_PATH})
    set(NULL ${PICO_DEBUG_INFO_IN_RELEASE})
endif()

## picotool 2.2.0-a4+dfsg

=== debian/changelog ===
picotool (2.2.0-a4+dfsg-2) unstable; urgency=medium

  * bump because of botched dgit push (flaky internet)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 11 Sep 2025 10:51:10 +0200

picotool (2.2.0-a4+dfsg-1) unstable; urgency=medium

  * New upstream version 2.2.0-a4+dfsg
     - debian/picotool.install: upstream changed
       udev/99-picotool.rules -> udev/60-picotool.rules
  * generate man pages for all subcommands from help output (Closes: #1108840)
  * debian/copyright: remove enc_bootloader.elf
  * debian/source/lintian-overrides: remove unused override
  * debian/salsa-ci.yml: enable cross builds
  * debian/patches: add cross.patch
  * debian/rules:
     - add more blhc ignore rules for targets compiled with arm-none-eabi-gcc
     - disable dh_dwz and dh_strip for /usr/share/picotool/enc_bootloader.elf
  * debian/control: bump pico-sdk version to 2.2.0
  * debian/picotool.lintian-overrides: add overrides for
    /usr/share/picotool/enc_bootloader.elf
  * Add patch disabling --print-memory-usage when linking (otherwise the
    linker output will be in the middle of a cmake log line and break blhc)
  * Build with --no-parallel for linear build logs (for blhc)
  * Added-AppStream-metainfo-XML-with-hardware-provide-i.patch: component id
    must have a .desktop suffix

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 10 Sep 2025 17:31:25 +0200

=== debian/control ===
Source: picotool
Section: libdevel
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Homepage: https://github.com/raspberrypi/picotool
Vcs-Browser: https://salsa.debian.org/debian/picotool
Vcs-Git: https://salsa.debian.org/debian/picotool.git
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 pandoc,
 libusb-1.0-0-dev,
 pico-sdk-source (>= 2.2.0),
 pkgconf,

Package: picotool
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: interact with RP2040/RP2350 devices or binaries
 Tool for interacting with a RP2040/RP2350 device in BOOTSEL mode, or with a
 RP2040/RP2350 binary. It allows one to load programs onto the device or save
 programs from flash to a file. It allows one to verify device contents or
 reboot the device.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for SOURCE_DATE_EPOCH
include /usr/share/dpkg/pkg-info.mk
DATE_MONTH_YEAR=$(shell env LC_ALL=C.UTF-8 date --utc --date=@${SOURCE_DATE_EPOCH} +"%B %Y")

# for DEB_HOST_GNU_TYPE
include /usr/share/dpkg/architecture.mk

# Do not run in parallel as different cmake invocations override each other's
# output. This also makes blhc fail.
# The underlying issue is that the upstream build system spawns cmake children
# via add_custom_command(COMMAND ${CMAKE_COMMAND}) so this is not even cmake's
# fault.
%:
	dh $@ --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- -DPICO_SDK_PATH=/usr/src/pico-sdk -DUSE_PRECOMPILED=0

# CFLAGS are intentionally missing because 32 bit arm eabi5 firmware files are
# not given the hardening flags (which would not be supported)
execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: .* -c /.*/xip_ram_perms/set_perms.c'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/otp_header_parser/otp_header_parse.cpp'
	@echo 'blhc: ignore-line-regexp: .* -c /usr/src/pico-sdk/.*'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/picoboot_flash_id/flash_id.c'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/xip_ram_perms/pico-sdk/src/rp2350/boot_stage2/bs2_default_padded_checksummed.S'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/picoboot_flash_id/pico-sdk/src/rp2040/boot_stage2/bs2_default_padded_checksummed.S'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/enc_bootloader/enc_bootloader.c'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/enc_bootloader/pico-sdk/src/rp2350/boot_stage2/bs2_default_padded_checksummed.S'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/enc_bootloader/aes.S'
	@echo 'blhc: ignore-line-regexp: .* -c /.*/enc_bootloader/hard_entry_point.S'
	@echo 'blhc: ignore-line-regexp: .* -o bs2_default.elf'
	@echo 'blhc: ignore-line-regexp: .* -o flash_id.elf'
	@echo 'blhc: ignore-line-regexp: .* -o otp_header_parse'
	@echo 'blhc: ignore-line-regexp: .* -o xip_ram_perms.elf'
	@echo 'blhc: ignore-line-regexp: .* -o enc_bootloader.elf'

override_dh_dwz:
	dh_dwz \
		--exclude=/usr/share/picotool/xip_ram_perms.elf \
		--exclude=/usr/share/picotool/enc_bootloader.elf

override_dh_strip:
	dh_strip \
		--exclude=/usr/share/picotool/xip_ram_perms.elf \
		--exclude=/usr/share/picotool/enc_bootloader.elf

execute_before_dh_installman:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# native build: verify that cached man pages didn't change
	./debian/manpages.sh verify "$(DEB_HOST_GNU_TYPE)" "$(DEB_VERSION_UPSTREAM)" "$(DATE_MONTH_YEAR)"
endif
	# if this was a cross-build, we can just use the cached files
	# if this was a native build, we verified its contents above
	set -e; for f in ./debian/man/*.md; do \
		pandoc "$$f" --standalone --to=man --output="./debian/man/$$(basename "$$f" .md).1" --metadata="footer:picotool $(DEB_VERSION_UPSTREAM)" --metadata="date: $(DATE_MONTH_YEAR)"; \
	done

execute_after_dh_auto_clean:
	rm -f picotool.1 ./xip_ram_perms/xip_ram_perms.elf

=== debian/tests/control ===
# This test is not in pico-sdk because releases of picotool and pico-sdk happen
# in tandem. When both packages release a new version, building picotool
# requires an equally new pico-sdk. The autokpgtest requires both packages to
# be at their latest version. If this test were in pico-sdk, then we would
# have to upload pico-sdk with a failing autopkgtest because picotool is still
# too old.
# So instead, we put this test into picotool and now we can first upload a new
# pico-sdk (without an autopkgtest) and then a new picotool once pico-sdk is
# in the archive.
Tests:
 hello-world,
Depends:
 build-essential,
 pico-sdk-source (>= 2.1.0),
 picotool,
Restrictions:
 allow-stderr,

=== debian/watch ===
version=4
 opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
     https://github.com/raspberrypi/picotool/tags \
     (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
